
; sequenceur radio a base de 12f675 
;a dure variable
; --par F5UBZ -- 03/2020 -- 
; version relais antenne bistable
; Ptt Par mise a la masse
 #include "p12f675.inc"

 __CONFIG _FOSC_INTRCIO & _WDTE_OFF & _PWRTE_OFF & _MCLRE_OFF & _BOREN_ON & _CP_OFF & _CPD_OFF

		  
ptt                 equ     0x03 ; entre PTT // mise a la masse 
tx_on	            equ     0x04 ; sortie  alimentation chaine tx (PA...)
rx_on               equ     0x05 ; sortie alimentaion chaine Rx (preampli ....)
ant_coil_tx         equ	    0x02 ; sortie bobine relais bistable (position TX)
ant_coil_rx         equ     0x01 ; sortie bobine relais bistable (position RX)

cnt	        equ 40h   ;
count           equ 41h   ;
temp            equ 42h   ;	   

                org 0
		goto start 	    ; vecteur de reset 
		
start           bcf STATUS,RP0
		clrf GPIO
		
		bsf STATUS,RP0
		movlw b'01010001'  ; GPIO0 = entre analogique
		movwf ANSEL        ; Fosc /16
		movlw b'00001001'  ; GP1,GPIO3 = entre digitale
		movwf TRISIO       ; GPIO2,GPIO3,GPIO4,GPIO5 = output digital               
		bcf STATUS,RP0

		movlw d'7'
		movwf CMCON    ;comparateur OFF	
       	
		
		movlw b'0000001'      ; demarrage  du
		movwf ADCON0          ; convertisseur A/N
		call wait_2ms         ;		
		
		bcf GPIO,tx_on
		bsf GPIO,ant_coil_rx
		call wait_an0_delay
		bcf GPIO,ant_coil_rx  ; forcage position rx au depart		
		bsf GPIO,rx_on	      ; initialisation des 3 sorties au depart		
		
main_loop       btfsc GPIO,ptt	      ; attente mise a la masse	
		goto $-1              ; du PTT
		bcf GPIO,rx_on
		call wait_an0_delay
		
		bsf GPIO,ant_coil_tx
		call wait_an0_delay
		bcf GPIO,ant_coil_tx  				
		bsf GPIO,tx_on 
		
		btfss GPIO,ptt   ; attente relache PTT
		goto $-1
		bcf GPIO,tx_on
		call wait_an0_delay
		bsf GPIO,ant_coil_rx
		call wait_an0_delay
		bcf GPIO,ant_coil_rx 				
			
		bsf GPIO,rx_on
		call wait_an0_delay
		goto main_loop    
		
wait_an0_delay 	bsf ADCON0,GO	  ; fonction
                btfsc ADCON0,GO   ; temporisation =
	        goto $-1          ; delais variable en 
		movf ADRESH,W     ; multiple de 2ms
		movwf cnt         ; donne par la valeur
		call wait_2ms     ; issu du convertisseur
		decfsz cnt,F      ; A/N : on ne tient comte
                goto $-2          ; que de 8 bits soit 512ms maxi
         	return 	
		
wait_2ms        movlw	D'4'	 ; fonction delais 2ms 
                movwf   count    ; a quelques s pres (pas critique)
outer_loop                        
	        movlw	H'A4'		
	        movwf	temp
inner_loop
	        decfsz	temp,f		
	        goto	inner_loop				
	        decfsz	count,f		
	        goto	outer_loop				
	        return			

		
		END
		



    	       